package de.intevation.flys.utils;

import java.io.Serializable;

import java.util.Comparator;

public class EpsilonComparator
implements   Serializable, Comparator<Double>
{
    public static final double EPSILON = 1e-5;

    public static final EpsilonComparator INSTANCE =
        new EpsilonComparator(EPSILON);

    protected double epsilon;

    public EpsilonComparator() {
        this(EPSILON);
    }

    public EpsilonComparator(double epsilon) {
        this.epsilon = Math.abs(epsilon);
    }

    private static final double value(Double x) {
        return x != null ? x.doubleValue() : 0.0;
    }

    @Override
    public int compare(Double a, Double b) {
        double diff = value(a) - value(b);
        if (diff < epsilon) return -1;
        return diff > epsilon ? +1 : 0;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
